<script lang="ts" setup>
import type { DynamicComponent } from '@/types/base';

const pageContent = defineProps({
  content: {
    type: Object as Array<DynamicComponent<never>>,
    required: true,
  },
});

if (!pageContent.content) {
  throw createError({
    statusCode: 500,
    message: `Page is missing the "content" attribute: ${path}`,
  });
}

const components = await useDynamicComponents(pageContent.content);
</script>

<!-- This is the common page builder. This template should be sufficient for most of pages as they follow the same pattern -->
<template>
  <template v-for="(component, index) of components" :key="index">
    <keep-alive>
      <component :is="component.resolvedComponent.default" v-bind="component.componentContent" />
    </keep-alive>
  </template>
</template>
